## pgrouting 2.3.2+ds

=== CMakeLists.txt ===
#
# Format convention
# - command (lower case)
# - VARIABLE (upper case)
# (http://www.cmake.org/cmake/help/v2.8.12/cmake.html)
#

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

#---------------------------------------------
# Setting kind of build
#---------------------------------------------
#
# On Master cmake -DMAKE_BUILD_TYPE=Release
#----------------------


message(STATUS "CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE}")
if(NOT CMAKE_BUILD_TYPE)
    if (UNIX)
        set(CMAKE_BUILD_TYPE Release CACHE STRING
            "Choose the type of build, options are: None Debug Release RelWithDebInfo
            MinSizeRel."
            FORCE)
        message("Running as: Release")
    else()
        set(CMAKE_BUILD_TYPE Release CACHE STRING
            "Choose the type of build, options are: None Debug Release RelWithDebInfo
            MinSizeRel."
            FORCE)
        message("Running as: Release")
    endif()
endif()
message(STATUS "CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE}")


#---------------------------------------------
#---------------------------------------------
#---------------------------------------------

project(PGROUTING)

#---------------------------------------------
#---------------------------------------------
#---------------------------------------------

if(POLICY CMP0046)
   cmake_policy(SET CMP0046 OLD)
endif()

if(MSVC)
    cmake_policy(SET CMP0046 OLD)
endif()

#=============================================
# Set the working directories
#=============================================

#---------------------------------------------
#  PgRouting_SOURCE_NAMES
#---------------------------------------------
#
# Name of the directories that have C/C++ code
#  - <directory>/src/CMakelists.txt must exist
#  - <directory>/sql/CMakeLists.txt  must exist
#----------------------

set(PgRouting_SOURCE_NAMES

    #----------------------
    # "common" must be first can not be removed
    #----------------------
    "common"

    #----------------------
    # "dijkstra" can not be removed 
    #   Has the command needed to link with prostgresl
    #----------------------
    "dijkstra" 

    #----------------------
    # Directories that have being rewritten
    #----------------------
    "allpairs"
    "astar"
    "driving_distance"
    "ksp"
    "tsp"

    #----------------------
    # Code needs to be rewritten
    #----------------------
    "alpha_shape"
    "bd_astar"
    "bd_dijkstra"
    "trsp"

    #----------------------
    # Proposed
    #  - Not officially on the release
    #  - number indicates version when was propsosed with code
    #----------------------
    "max_flow"    # 2.3
    "contraction" # 2.3
    "pickDeliver" # 2.3
    "vrp_basic"   # 2.0 
    "withPoints"  # 2.2

    # template generated name
    #"funnyDijkstra"

    )

#-----------------------------------------------------------------------------
# Name of the directories containing only SQL files
#
#  - <directory>/sql/CMakeLists.txt  must exist
#-----------------------------------------------------------------------------
set(PgRouting_SQL_DIRECTORIES 

    "topology"     # needs to be revised

    #----------------------
    # Proposed
    #  Not officially on the release
    #----------------------
    "convenience"  # most are deprecated
    "label_graph"  # needs to be rewritten using Boost
    "costMatrix"   # proposed on 2.3

    #----------------------
    # Wrappers for backwards compatibility 
    #----------------------
    "apsp_johnson"  # 2.0 wrap of pgr_johnson
    "apsp_warshall" # 2.0 wrap of pgr_warshall
    "kdijkstra"     # 2.0 wrap of pgr_dijkstra & pgr_dijkstraCost
    "vrppdtw"       # 2.1 wraps of _pgr_pickDeliver 

    )

#---------------------------------------------
# minimum versions
#---------------------------------------------
set(DOXYGEN_MINIMUM_VERSION "1.8.6")
set(SPHINX_MINIMUM_VERSION "1.1")

message(STATUS "DOXYGEN_MINIMUM_VERSION=${DOXYGEN_MINIMUM_VERSION}")
message(STATUS "SPHINX_MINIMUM_VERSION=${SPHINX_MINIMUM_VERSION}")


#---------------------------------------------
# C++ Compiler requirements
#---------------------------------------------


include(CheckCXXCompilerFlag)

if (NOT MSVC) 
    CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
    message(STATUS "COMPILER_SUPPORTS_CXX0X= ${COMPILER_SUPPORTS_CXX0X}")
    message(STATUS "CMAKE_CXX_COMPILER= ${CMAKE_CXX_COMPILER}")
    if(COMPILER_SUPPORTS_CXX0X)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    else()
        CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
        message(STATUS "COMPILER_SUPPORTS_CXX11= ${COMPILER_SUPPORTS_CXX11}")
        if(COMPILER_SUPPORTS_CXX11)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
        else()
            message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} has no C++0x nor C++11 support.
            Please use a different C++ compiler.")
        endif()
    endif()
endif()

#-----------------------------------------------------------------------------
# PGROUTING version number.
set(PGROUTING_VERSION_MAJOR "2")
set(PGROUTING_VERSION_MINOR "3")
set(PGROUTING_VERSION_PATCH "2")

set(PGROUTING_VERSION_STRING "${PGROUTING_VERSION_MAJOR}.${PGROUTING_VERSION_MINOR}.${PGROUTING_VERSION_PATCH}")
set(PGROUTING_VERSION "${PGROUTING_VERSION_MAJOR}.${PGROUTING_VERSION_MINOR}")

set(POSTGRESQL_MINIMUM_VERSION "9.1.0")
set(POSTGIS_MINIMUM_VERSION "2.0.0")

file(STRINGS "${PGROUTING_SOURCE_DIR}/VERSION" PGROUTING_BUILD_STRING)

set(PGROUTING_GIT_TAG "v2.3.2")

#string(REGEX REPLACE "^(.+)-([0-9]+)-g([0-9a-f]+) (.*)$" "\\1" PGROUTING_GIT_TAG ${PGROUTING_BUILD_STRING})
string(REGEX REPLACE "^(.+)-([0-9a-f]+) (.*)$" "\\1" PGROUTING_GIT_BUILD ${PGROUTING_BUILD_STRING})
string(REGEX REPLACE "^(.+)-([0-9a-f]+) (.*)$" "\\2" PGROUTING_GIT_HASH ${PGROUTING_BUILD_STRING})
string(REGEX REPLACE "^(.+)-([0-9a-f]+) (.*)$" "\\3" PGROUTING_GIT_BRANCH ${PGROUTING_BUILD_STRING})

set(PGROUTING_VERSION_REVISION_NAME "${PGROUTING_GIT_HASH} ${PGROUTING_GIT_BRANCH}")
set(PGROUTING_VERSION_REVISION_HASH "${PGROUTING_GIT_HASH}")

message(STATUS "CMAKE_VERSION: ${CMAKE_VERSION}")
message(STATUS "PGROUTING_BUILD_STRING: ${PGROUTING_BUILD_STRING}")
message(STATUS "PGROUTING_GIT_TAG: ${PGROUTING_GIT_TAG}")
message(STATUS "PGROUTING_GIT_BUILD: ${PGROUTING_GIT_BUILD}")
message(STATUS "PGROUTING_GIT_HASH: ${PGROUTING_GIT_HASH}")
message(STATUS "PGROUTING_GIT_BRANCH: ${PGROUTING_GIT_BRANCH}")
message(STATUS "PGROUTING_VERSION_REVISION_NAME: ${PGROUTING_VERSION_REVISION_NAME}")

message(STATUS "PGROUTING_SOURCE_DIR: ${PGROUTING_SOURCE_DIR}")
message(STATUS "CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}")

message(STATUS "PGROUTING_VERSION_REVISION_HASH: ${PGROUTING_VERSION_REVISION_HASH}")
message(STATUS "POSTGRESQL_BIN: ${POSTGRESQL_BIN}")



#-----------------------------------------------------------------------------
# CMAKE configuration
# This is for my mingw64 environment, it should go away
set(CMAKE_PREFIX_PATH /usr:/usr/local)
set(CMAKE_INCLUDE_PATH /usr:/usr/local)
set(CMAKE_LIBRARY_PATH /usr:/usr/local)

add_subdirectory(cmake)
set(CMAKE_MODULE_PATH "${PGROUTING_SOURCE_DIR}/cmake")

include(MacroLibrary)
include(TargetDistclean)

if(WIN32 AND NOT MSVC)
    set(OS_BUILD  $ENV{OS_BUILD})
    if(NOT OS_BUILD)
        set(OS_BUILD "64")
    endif(NOT OS_BUILD)
    set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH}:/c/ming${OS_BUILD}/projects/pgx${OS_BUILD}/pg92)
    if (NOT BOOST_ROOT)
        set(BOOST_ROOT c:/ming${OS_BUILD}/msys/local)
    endif(NOT BOOST_ROOT)

    if (NOT CGAL_ROOT)
        set(CGAL_ROOT c:/ming${OS_BUILD}/msys/local)
    endif(NOT CGAL_ROOT)

    if (NOT GMP_ROOT)
        set(GMP_ROOT c:/ming${OS_BUILD}/mingw${OS_BUILD})
    endif(NOT GMP_ROOT)
    message(STATUS "OS_BUILD=${OS_BUILD}")
    message(STATUS "CGAL_ROOT=${CGAL_ROOT}")
    message(STATUS "GMP_ROOT=${GMP_ROOT}")
    message(STATUS "BOOST_ROOT=${BOOST_ROOT}")
    message(STATUS "CMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}")
endif(WIN32 AND NOT MSVC)


include(FindPerl)
if(NOT PERL_EXECUTABLE)
    message(FATAL_ERROR " Please check your Perl installation.")
endif(NOT PERL_EXECUTABLE)

find_package(PostgreSQL)
if(NOT POSTGRESQL_FOUND)
    message(FATAL_ERROR " Please check your PostgreSQL installation.") 
endif(NOT POSTGRESQL_FOUND)

#set(Boost_DEBUG ON)
find_package(Boost)
if(Boost_INCLUDE_DIRS)
    message(STATUS "Boost headers were found here: ${Boost_INCLUDE_DIRS}")
    #find_file(MYVAR geometry.hpp)
    #message(STATUS "geometry.hpp  found here: ${MYVAR}")
else(Boost_INCLUDE_DIRS)
    message(FATAL_ERROR " Please check your Boost installation ") 
endif(Boost_INCLUDE_DIRS)

find_package(CGAL)
if(NOT CGAL_FOUND)
    message(FATAL_ERROR " Please check your CGAL installation, or set correct path to CGAL_INCLUDE_DIR and CGAL_LIBRARIES.")
endif(NOT CGAL_FOUND)

if(NOT POSTGRESQL_VERSION_STRING)
    message(FATAL_ERROR "pg_config was not found. Please check your PostgreSQL installation!")
endif(NOT POSTGRESQL_VERSION_STRING)

message(STATUS "POSTGRESQL_VERSION_STRING is ${POSTGRESQL_VERSION_STRING}")
string(SUBSTRING "${POSTGRESQL_VERSION_STRING}" 11 -1 POSTGRESQL_VERSION)
message(STATUS "POSTGRESQL_VERSION is ${POSTGRESQL_VERSION}")
string(REGEX REPLACE "^([0-9]+)\\.([0-9]+).*" "\\1\\2" PGSQL_VERSION ${POSTGRESQL_VERSION})
message(STATUS "PGSQL_VERSION is ${PGSQL_VERSION}")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DPGSQL_VERSION=${PGSQL_VERSION}")

#TODO maybe needs a wrapper for visual studio
if(WIN32 AND MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_SECURE_NO_DEPRECATE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_SCL_SECURE_NO_DEPRECATE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_SECURE_NO_WARNINGS")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_SCL_SECURE_NO_WARNINGS")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_NONSTDC_NO_DEPRECATE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -EHsc")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_C_FLAGS}")
endif()

if("${POSTGRESQL_VERSION}" VERSION_LESS "${POSTGRESQL_MINIMUM_VERSION}")
    message(FATAL_ERROR " PostgreSQL ${POSTGRESQL_MINIMUM_VERSION} or greater is required.")
endif("${POSTGRESQL_VERSION}" VERSION_LESS "${POSTGRESQL_MINIMUM_VERSION}")


execute_process(
    COMMAND ${POSTGRESQL_PG_CONFIG} --pkglibdir
    OUTPUT_STRIP_TRAILING_WHITESPACE
    OUTPUT_VARIABLE LIB_DIR)

if(LIB_DIR)
    message(STATUS "Install directory for libraries is set to ${LIB_DIR}")
else(LIB_DIR)
    message(FATAL_ERROR "pg_config --pkglibdir failed to return a value. Please check your PostgreSQL installation!")
endif(LIB_DIR)

set(LIBRARY_INSTALL_PATH ${LIB_DIR})

execute_process(
    COMMAND ${POSTGRESQL_PG_CONFIG} --sharedir
    OUTPUT_STRIP_TRAILING_WHITESPACE
    OUTPUT_VARIABLE SHARE_DIR)

if(SHARE_DIR)
    set(SHARE_DIR "${SHARE_DIR}/extension")
    message(STATUS "Extension directory for SQL files is set to ${SHARE_DIR}")
else(SHARE_DIR)
    message(FATAL_ERROR "pg_config --sharedir failed to return a value. Please check your PostgreSQL installation!")
endif(SHARE_DIR)

#-------------------------------------
# Handles documentation
#-------------------------------------
set(PROJECT_NAME  "pgRouting")
set(PROJECT_BRIEF "pgRouting extends the PostGIS / PostgreSQL geospatial database to provide geospatial routing functionality.")
set(PROJECT_NUMBER  "${PGROUTING_GIT_TAG}")
add_subdirectory(doxygen)
add_subdirectory(doc)
#-------------------------------------

#include directories: files in alphabetical order
set(PGROUTING_INCLUDE_DIRECTORIES
    ${PGROUTING_SOURCE_DIR}/src/common/src
    ${PGROUTING_SOURCE_DIR}/src/dijkstra/src
    )

include_directories(${PGROUTING_INCLUDE_DIRECTORIES} ${POSTGRESQL_INCLUDE_DIR} ${Boost_INCLUDE_DIRS} ${CGAL_INCLUDE_DIR})
message(STATUS "PGROUTING_INCLUDE_DIRECTORIES = ${PGROUTING_INCLUDE_DIRECTORIES}")
message(STATUS "POSTGRESQL_INCLUDE_DIR = ${POSTGRESQL_INCLUDE_DIR}")
message(STATUS "Boost_INCLUDE_DIRS = ${Boost_INCLUDE_DIRS}")

=== src/trsp/sql/CMakeLists.txt ===
# Append in local scope
list(APPEND PACKAGE_SQL_FILES
    #${CMAKE_CURRENT_SOURCE_DIR}/routing_trsp.sql
    #${CMAKE_CURRENT_SOURCE_DIR}/routing_trsp_vias.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/trsp_V2.2.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/vias_trsp_V2.2.sql
    )

# set in parent scope
set(PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}" PARENT_SCOPE)

=== debian/changelog ===
pgrouting (2.3.2+ds-2) unstable; urgency=medium

  * Team upload.
  * Add postgis to build dependencies to limit archs to where it's available.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 10 Jan 2017 19:34:33 +0100

pgrouting (2.3.2+ds-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 09 Jan 2017 19:20:33 +0100

pgrouting (2.3.2+ds-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file for other CC-BY-SA-3.0 documentation.
  * Split SQL scripts off into separate arch:all package.
  * Repack upstream tarball to exclude .gitattributes file,
    causes changes to the upstream source with git-buildpackage.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 07 Jan 2017 22:25:55 +0100

pgrouting (2.3.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 20 Nov 2016 22:11:08 +0100

pgrouting (2.3.0-2) unstable; urgency=medium

  * Team upload.
  * Change pgversions from 'all' to '9.2+' to match postgis.
  * Add autopkgtest installability test.
    (closes: #839127)

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 02 Oct 2016 10:20:16 +0200

=== debian/control ===
Source: pgrouting
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Michael Fladischer <FladischerMichael@fladi.at>
Section: misc
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               libboost-graph-dev,
               libcgal-dev,
               libjs-mathjax,
               postgis,
               postgresql-server-dev-all,
               python-sphinx (>= 1.0.7+dfsg)
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/pgrouting.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/pgrouting.git
Homepage: http://www.pgrouting.org

Package: postgresql-9.6-pgrouting
Architecture: any
Depends: postgresql-9.6-pgrouting-scripts (>= ${source:Version}),
         postgresql-9.6,
         postgresql-9.6-postgis-2.3,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: postgresql-9.6-pgrouting-doc
Description: Routing functionality support for PostgreSQL/PostGIS
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package supports PostgreSQL 9.6.

Package: postgresql-9.6-pgrouting-scripts
Architecture: all
Depends: ${misc:Depends}
Breaks: postgresql-9.6-pgrouting (<< 2.3.2)
Replaces: postgresql-9.6-pgrouting (<< 2.3.2)
Description: Routing functionality support for PostgreSQL/PostGIS - scripts
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains SQL scripts to upgrade from earlier pgRouting
 versions for PostgreSQL 9.6.

Package: postgresql-9.6-pgrouting-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: Routing functionality support for PostgreSQL/PostGIS (Documentation)
 pgRouting extends the PostGIS/PostgreSQL geospatial database to provide
 geospatial routing and other network analysis functionality.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

include /usr/share/postgresql-common/pgxs_debian_control.mk

%:
	dh $@ --with sphinxdoc --parallel

override_dh_auto_configure:
	set -e; \
	for v in $$(pg_buildext supported-versions); do \
		cmake -H. -Bbuild-$$v -DWITH_DOC=ON -DPOSTGRESQL_PG_CONFIG=/usr/lib/postgresql/$$v/bin/pg_config -DCMAKE_VERBOSE_MAKEFILE=1; \
	done

override_dh_auto_build:
	+pg_buildext build build-%v
	set -e; \
	for v in $$(pg_buildext supported-versions); do \
		make -C build-$$v doc; \
		rm build-$$v/doc/html/en/_static/images/pgrouting.png; \
		ln -s ../pgrouting.png build-$$v/doc/html/en/_static/images/pgrouting.png; \
		rm build-$$v/doc/html/en/_static/images/ccbysa.png; \
		ln -s ../../_images/ccbysa.png build-$$v/doc/html/en/_static/images/ccbysa.png; \
		ln -s /usr/share/javascript/mathjax build-$$v/doc/html/en/_static/mathjax; \
	done

override_dh_auto_install:
	+pg_buildext install build-%v postgresql-%v-pgrouting
	set -e; \
	for v in $$(pg_buildext supported-versions); do \
		mkdir -p debian/postgresql-$$v-pgrouting-doc/usr/share/doc/postgresql-$$v-pgrouting-doc; \
		cp -r build-$$v/doc/html debian/postgresql-$$v-pgrouting-doc/usr/share/doc/postgresql-$$v-pgrouting-doc; \
		mkdir -p debian/postgresql-$$v-pgrouting-doc/usr/share/doc-base; \
		sed "s,PGVERSION,$$v,g" < debian/postgresql-pgrouting-doc.doc-base.in > debian/postgresql-$$v-pgrouting-doc/usr/share/doc-base/postgresql-$$v-pgrouting-doc; \
		mkdir -p debian/postgresql-$$v-pgrouting-scripts/usr; \
		mv debian/postgresql-$$v-pgrouting/usr/share debian/postgresql-$$v-pgrouting-scripts/usr; \
	done

override_dh_auto_clean:
	+pg_buildext clean build-%v

override_dh_clean:
	dh_clean debian/postgresql-*-pgrouting.install \
	         debian/postgresql-*-pgrouting-scripts.install

override_dh_sphinxdoc-indep:
	dh_sphinxdoc -Xtheme_extras.js

override_dh_sphinxdoc-arch:

override_dh_install:
	dh_install --list-missing

override_dh_installchangelogs:
	dh_installchangelogs doc/src/changelog/release_notes.rst

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/postgresql

## pgrouting 2.4.2

=== CMakeLists.txt ===
#
# Format convention
# - command (lower case)
# - VARIABLE (upper case)
# (http://www.cmake.org/cmake/help/v2.8.12/cmake.html)
#

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

if(POLICY CMP0046)
    cmake_policy(SET CMP0046 OLD)
endif()

if ( ${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR} )
        message(FATAL_ERROR "In-source builds not allowed.
        Please make a new directory (called a build directory) and run CMake from there.
        You may need to remove CMakeCache.txt." )
endif()

#---------------------------------------------
# Setting kind of build
#---------------------------------------------
#
# for developing
# cmake -DMAKE_BUILD_TYPE=Develop
#----------------------

message(STATUS "CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE}")
if (CMAKE_BUILD_TYPE MATCHES Develop)
    set(CMAKE_BUILD_TYPE Debug CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo
        MinSizeRel."
        FORCE)
    set(WITH_INTERNAL_TESTS)
endif()
message(STATUS "CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE}")


#---------------------------------------------
#---------------------------------------------
#---------------------------------------------

project(PGROUTING)

#---------------------------------------------
#---------------------------------------------
#---------------------------------------------

if(POLICY CMP0046)
   cmake_policy(SET CMP0046 OLD)
endif()

if(MSVC)
    cmake_policy(SET CMP0046 OLD)
endif()

#=============================================
# Set the working directories
#=============================================

#---------------------------------------------
#  PgRouting_SOURCE_NAMES
#---------------------------------------------
#
# Name of the directories that have C/C++ code
#  - <directory>/src/CMakelists.txt must exist
#  - <directory>/sql/CMakeLists.txt  must exist
#----------------------

set(PgRouting_SOURCE_NAMES

    #----------------------
    # "common" must be first can not be removed
    #----------------------
    "common"

    #----------------------
    # "dijkstra" can not be removed 
    #   Has the command needed to link with prostgresl
    #----------------------
    "dijkstra" 

    #----------------------
    # Directories that have being rewritten
    #----------------------
    "allpairs"
    "astar"
    "driving_distance"
    "ksp"
    "tsp"

    #----------------------
    # Code needs to be rewritten
    #----------------------
    "alpha_shape"
    "bd_astar"
    "bdDijkstra" # 2.4
    "trsp"

    #----------------------
    # Proposed
    #  - Not officially on the release
    #  - number indicates version when was propsosed with code
    #----------------------
    "max_flow"    # 2.3
    "contraction" # 2.3
    "pickDeliver" # 2.3
    "vrp_basic"   # 2.0 
    "withPoints"  # 2.2

    # template generated name
    #"funnyDijkstra"

    )

#-----------------------------------------------------------------------------
# Name of the directories containing only SQL files
#
#  - <directory>/sql/CMakeLists.txt  must exist
#-----------------------------------------------------------------------------
set(PgRouting_SQL_DIRECTORIES 

    "topology"     # needs to be revised

    #----------------------
    # Proposed
    #  Not officially on the release
    #----------------------
    "convenience"  # most are deprecated
    "label_graph"  # needs to be rewritten using Boost
    "costMatrix"   # proposed on 2.3

    #----------------------
    # Wrappers for backwards compatibility 
    #----------------------
    "bd_dijkstra"   # 2.0 wrap of pgr_bdDijkstra
    "apsp_johnson"  # 2.0 wrap of pgr_johnson
    "apsp_warshall" # 2.0 wrap of pgr_warshall
    "kdijkstra"     # 2.0 wrap of pgr_dijkstra & pgr_dijkstraCost
    "vrppdtw"       # 2.1 wraps of _pgr_pickDeliver
    )

#---------------------------------------------
# minimum versions
#---------------------------------------------
set(DOXYGEN_MINIMUM_VERSION "1.7")
set(SPHINX_MINIMUM_VERSION "1.1")
set(POSTGRESQL_MINIMUM_VERSION "9.2.0")
set(BOOST_MINIMUM_VERSION "1.46")
set(CGAL_CXX_MINIMUM_VERSION "4.4")
set(POSTGIS_MINIMUM_VERSION "2.0.0")
set(GNU_CXX_MINIMUM_VERSION "4.6")
set(MSVC_CXX_MINIMUM_VERSION "18.0")

message(STATUS "DOXYGEN_MINIMUM_VERSION=${DOXYGEN_MINIMUM_VERSION}")
message(STATUS "SPHINX_MINIMUM_VERSION=${SPHINX_MINIMUM_VERSION}")
message(STATUS "POSTGRESQL_MINIMUM_VERSION=${POSTGRESQL_MINIMUM_VERSION}")
message(STATUS "POSTGIS_MINIMUM_VERSION=${POSTGIS_MINIMUM_VERSION}")
message(STATUS "GNU_CXX_MINIMUM_VERSION=${GNU_CXX_MINIMUM_VERSION}")
message(STATUS "CLANG_CXX_MINIMUM_VERSION=${CLANG_CXX_MINIMUM_VERSION}")
message(STATUS "MSVC_CXX_MINIMUM_VERSION=${MSVC_CXX_MINIMUM_VERSION}")


#---------------------------------------------
# adding cmake modules
#---------------------------------------------

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
foreach(dir ${CMAKE_MODULE_PATH})
    message(STATUS "dir='${dir}'")
endforeach()

include(MacroLibrary)
include(TargetDistclean)

#---------------------------------------------
# C++ Compiler requirements
#---------------------------------------------

include(CheckCXXCompilerFlag)

CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS GNU_CXX_MINIMUM_VERSION)
        message(FATAL_ERROR "GCC version must be at least ${GNU_CXX_MINIMUM_VERSION}!")
    endif()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS MSVC_CXX_MINIMUM_VERSION)
        message(FATAL_ERROR "MSVC version must be at least ${MSVC_CXX_MINIMUM_VERSION}!")
    endif()
else()
    message(STATUS "Unknown compiler minimum version for ${CMAKE_CXX_COMPILER_ID}")
endif()

if(COMPILER_SUPPORTS_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
elseif(COMPILER_SUPPORTS_CXX0X)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
else()
    message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++0x or C++11 flags support.")
endif()


#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
# PGROUTING version variables
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------

set(PGROUTING_VERSION_MAJOR "2")
set(PGROUTING_VERSION_MINOR "4")
set(PGROUTING_VERSION_PATCH "2")
set(PGROUTING_VERSION_DEV "")

set(PGROUTING_SHORT_VERSION "${PGROUTING_VERSION_MAJOR}.${PGROUTING_VERSION_MINOR}")
set(PGROUTING_VERSION "${PGROUTING_VERSION_MAJOR}.${PGROUTING_VERSION_MINOR}.${PGROUTING_VERSION_PATCH}")
set(PGROUTING_FULL_VERSION "v${PGROUTING_VERSION}${PGROUTING_VERSION_DEV}")


#---------------------------------------------
# Variables used in pgr_version()
#---------------------------------------------
file(STRINGS "${PGROUTING_SOURCE_DIR}/VERSION" PGROUTING_BUILD_STRING)

#string(REGEX REPLACE "^(.+)-([^-]+)-[0-9]+-([0-9a-f]+) (.*)$" "\\2" PGROUTING_GIT_BUILD ${PGROUTING_BUILD_STRING})
string(REGEX REPLACE "^([0-9]+)-([0-9a-f]+) (.*)$" "\\2" PGROUTING_GIT_HASH ${PGROUTING_BUILD_STRING})
string(REGEX REPLACE "^([0-9]+)-([0-9a-f]+) (.*)$" "\\3" PGROUTING_GIT_BRANCH ${PGROUTING_BUILD_STRING})


if (PGROUTING_DEBUG)
    message(STATUS "PGROUTING_VERSION: ${PGROUTING_FULL_VERSION}")
    message(STATUS "PGROUTING_SHORT_VERSION: ${PGROUTING_FULL_VERSION}")
    message(STATUS "PGROUTING_FULL_VERSION: ${PGROUTING_FULL_VERSION}")
    message(STATUS "VERSION file contents: ${PGROUTING_BUILD_STRING}")
    message(STATUS "PGROUTING_GIT_HASH: ${PGROUTING_GIT_HASH}")
    message(STATUS "PGROUTING_GIT_BRANCH: ${PGROUTING_GIT_BRANCH}")
    message(STATUS "CMAKE_VERSION: ${CMAKE_VERSION}")
    message(STATUS "PGROUTING_SOURCE_DIR: ${PGROUTING_SOURCE_DIR}")
    message(STATUS "CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}")
endif()


#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
# Windows compiler flags
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------


if(WIN32 AND NOT MSVC)
    set(OS_BUILD  $ENV{OS_BUILD})
    if(NOT OS_BUILD)
        set(OS_BUILD "64")
    endif(NOT OS_BUILD)
    set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH}:/c/ming${OS_BUILD}/projects/pgx${OS_BUILD}/pg92)
    if (NOT BOOST_ROOT)
        set(BOOST_ROOT c:/ming${OS_BUILD}/msys/local)
    endif(NOT BOOST_ROOT)

    if (NOT CGAL_ROOT)
        set(CGAL_ROOT c:/ming${OS_BUILD}/msys/local)
    endif(NOT CGAL_ROOT)

    if (NOT GMP_ROOT)
        set(GMP_ROOT c:/ming${OS_BUILD}/mingw${OS_BUILD})
    endif(NOT GMP_ROOT)
    if (PGROUTING_DEBUG)
        message(STATUS "OS_BUILD=${OS_BUILD}")
        message(STATUS "CGAL_ROOT=${CGAL_ROOT}")
        message(STATUS "GMP_ROOT=${GMP_ROOT}")
        message(STATUS "BOOST_ROOT=${BOOST_ROOT}")
        message(STATUS "CMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}")
    endif()
endif(WIN32 AND NOT MSVC)

if(WIN32 AND MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_SECURE_NO_DEPRECATE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_SCL_SECURE_NO_DEPRECATE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_SECURE_NO_WARNINGS")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_SCL_SECURE_NO_WARNINGS")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_CRT_NONSTDC_NO_DEPRECATE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -EHsc")
endif()

#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
# Finding prerequisites
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------

#---------------------------------------------
#---------------------------------------------
# Perl
#---------------------------------------------
#---------------------------------------------
include(FindPerl)
if(NOT PERL_EXECUTABLE)
    message(FATAL_ERROR " Please check your Perl installation.")
endif(NOT PERL_EXECUTABLE)

#---------------------------------------------
#---------------------------------------------
# PostgreSQL
#---------------------------------------------
#---------------------------------------------
find_package(PostgreSQL)
if(NOT POSTGRESQL_FOUND)
    message(FATAL_ERROR " Please check your PostgreSQL installation.") 
endif(NOT POSTGRESQL_FOUND)

if(NOT POSTGRESQL_VERSION_STRING)
    message(FATAL_ERROR "pg_config was not found. Please check your PostgreSQL installation!")
endif(NOT POSTGRESQL_VERSION_STRING)

string(SUBSTRING "${POSTGRESQL_VERSION_STRING}" 11 -1 POSTGRESQL_VERSION)

# for XbetaY XalphaY XrcY -> X.Y
string(REGEX REPLACE "^([0-9]+)[beta|alpha|rc].*" "\\1.0" POSTGRESQL_VERSION ${POSTGRESQL_VERSION})

#for X.Y.Z -> XY  Y<10 
string(REGEX REPLACE "^([0-9]+)\\.([0-9]+).*" "\\1\\2" PGSQL_VERSION ${POSTGRESQL_VERSION})


if("${POSTGRESQL_VERSION}" VERSION_LESS "${POSTGRESQL_MINIMUM_VERSION}")
    message(FATAL_ERROR " PostgreSQL ${POSTGRESQL_MINIMUM_VERSION} or greater is required.")
endif("${POSTGRESQL_VERSION}" VERSION_LESS "${POSTGRESQL_MINIMUM_VERSION}")

#-------
include_directories(${POSTGRESQL_INCLUDE_DIR})
if(WIN32)
    include_directories(${POSTGRESQL_INCLUDE_DIR}/port/win32)
    if(MSVC)
        include_directories(${POSTGRESQL_INCLUDE_DIR}/port/win32_msvc/)
    endif(MSVC)
endif(WIN32)

=== doc/CMakeLists.txt ===
# 
# Find Sphinx
# Find Sphinx executable to build documentation
# Source: http://ericscottbarr.com/blog/2012/03/sphinx-and-cmake-beautiful-documentation-for-c-projects/
# 
# Daniel Kastl 03/2013
#

option(WITH_DOC
     "Set ON|OFF (default=OFF) to build Documentation library tree" OFF)

option(BUILD_LATEX
    "Set ON|OFF (default=OFF) to build Documentation library tree as PDF" OFF)

option(BUILD_HTML
    "Set ON|OFF (default=ON) to build Documentation library tree as HTML" ON)

option(BUILD_MAN
    "Set ON|OFF (default=ON) to build Documentation library tree as MAN page" OFF)

option(DOC_USE_BOOTSTRAP
    "Set ON|OFF (default=ON) to build Documentation library tree as MAN page" OFF)


if(WITH_DOC)
    #message("PROCESSING DOCUMENTATION------------")

    find_package(Sphinx REQUIRED)

    if (DOC_USE_BOOTSTRAP)
        set(SPHINX_INCLUDE "import sphinx_bootstrap_theme")
        set(SPHINX_THEME "bootstrap")
        set(SPHINX_THEME_DIR "sphinx_bootstrap_theme.get_html_theme_path()")
        set(SPHINX_THEME_OPTIONS "'source_link_position': \"none\",")
    else()
        set(SPHINX_INCLUDE "")
        set(SPHINX_THEME "haiku")
        set(SPHINX_THEME_DIR "['']")
        set(SPHINX_THEME_OPTIONS "")
    endif()



    if (NOT SPHINX_FOUND)
        message(WARNING "Sphinx not found. Cannot generate documentation!")
    else()
        if (SPHINX_VERSION VERSION_LESS 1.0)
            message(WARNING "Your Sphinx version is too old!
            This project requires Sphinx v1.0 or above to produce
            proper documentation (you have v${SPHINX_VERSION}).
            You will get output but it will have errors.")
        endif()

        if(NOT DEFINED SPHINX_THEME)
            set(SPHINX_THEME default)
        endif()

        if(NOT DEFINED SPHINX_THEME_DIR)
            set(SPHINX_THEME_DIR)
        endif()

        # configured documentation tools and intermediate build results
        set(PGR_DOCUMENTATION_BUILD_DIR "${PGROUTING_BINARY_DIR}/doc/_build")
        set(PGR_DOCUMENTATION_SOURCE_DIR "${PGROUTING_BINARY_DIR}/doc")

        message(STATUS "PGR_DOCUMENTATION_BUILD_DIR = ${PGR_DOCUMENTATION_BUILD_DIR}")

        # ---------- TO FLATTEN THE DOCUMENTATION ---------

        file(GLOB PGR_DOCUMENTATION_SOURCES "src/*")
        foreach (file ${PGR_DOCUMENTATION_SOURCES})
            #message("${file}")
            file(COPY "${file}" DESTINATION "${PGR_DOCUMENTATION_SOURCE_DIR}")
        endforeach()

        file(GLOB  PGR_DOCUMENTATION_SOURCES "../src/*/doc/*")
        foreach (file ${PGR_DOCUMENTATION_SOURCES})
            #message("${file}")
            file(COPY "${file}" DESTINATION "${PGR_DOCUMENTATION_SOURCE_DIR}")
        endforeach()

        file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/index.rst" DESTINATION "${PGR_DOCUMENTATION_SOURCE_DIR}")
        file(COPY "../tools/testers/sampledata.sql" DESTINATION "${PGR_DOCUMENTATION_SOURCE_DIR}/sampledata/")


        #message(STATUS "PGROUTING_BINARY_DIR = ${PGROUTING_BINARY_DIR}")

        # Sphinx cache with pickled ReST documents
        set(SPHINX_CACHE_DIR "${PGROUTING_BINARY_DIR}/doc/_doctrees")

        file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/static" DESTINATION "${PGR_DOCUMENTATION_BUILD_DIR}")
        file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/themes" DESTINATION "${PGR_DOCUMENTATION_BUILD_DIR}")
        file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/CNAME" DESTINATION "${PGROUTING_BINARY_DIR}")

        #configure_file(
        #    "${CMAKE_CURRENT_SOURCE_DIR}/index.html.in"
        #    "${PGROUTING_BINARY_DIR}/doc/html/index.html")

        configure_file(
            "${CMAKE_CURRENT_SOURCE_DIR}/forward.html"
            "${PGROUTING_BINARY_DIR}/doc/html/en/index.html")

        # Add documentation to targets
        set(DOC_TARGETS html)

        #option(BUILD_MAN "Create a target for building man pages." ON)

        if (BUILD_MAN)
            if (SPHINX_VERSION VERSION_LESS 1.0)
                message(WARNING "Sphinx version 1.0 > is required to build man pages. You have v${SPHINX_VERSION}.")
            else()
                list(APPEND DOC_TARGETS man)
            endif()
        endif()

        #option(BUILD_LATEX "Create a target for building latex docs (to create PDF)." ON)

        if (BUILD_LATEX)
            find_package(LATEX)

            if (NOT LATEX_COMPILER)
                message("Couldn't find Latex, can't build latex docs using Sphinx")
            else()
                message(STATUS "LATEX_COMPILER = ${LATEX_COMPILER}")
                list(APPEND DOC_TARGETS latex)
            endif()
        endif()

        # The doc target will build all documentation targets.
        add_custom_target(doc #ALL
            COMMENT "Building documentation with Sphinx")
        # add_custom_target(doc)

        # Localization output directory
        #set(SPHINX_I18N_DIR "${CMAKE_CURRENT_SOURCE_DIR}/i18n/pot")

        configure_file(
            "${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in"
            "${PGR_DOCUMENTATION_BUILD_DIR}/conf.py"
            @ONLY)

        foreach (DOC_TARGET ${DOC_TARGETS})
            add_custom_command(
                TARGET doc POST_BUILD
                COMMAND ${SPHINX_EXECUTABLE} 
                # -q  # Enable for quiet mode 
                # -Q  # Enable for even more quiet mode
                # -v  # increase verbosity
                -b ${DOC_TARGET}
                -E  # don't use a saved environment, always read all file
                -a  # write all files; default is to only write new and changed files
                -d "${SPHINX_CACHE_DIR}" 
                -c "${PGR_DOCUMENTATION_BUILD_DIR}" 
                "${PGR_DOCUMENTATION_SOURCE_DIR}" 
                "${PGROUTING_BINARY_DIR}/doc/${DOC_TARGET}/en"
                COMMENT "Generating ${DOC_TARGET} documentation ...")
        endforeach()

        if(BUILD_LATEX)
            if(LATEX_COMPILER)
                add_custom_command(
                    TARGET doc POST_BUILD
                    #fixes: Underfull \hbox (badness 10000) in paragraph
                    #perl -pi -e 's/warning/warning /' pgRoutingDocumentation.tex
                    COMMAND pdflatex 
                    -interaction=nonstopmode 
                    "pgRoutingDocumentation.tex" > /dev/null 2>&1
                    WORKING_DIRECTORY "${PGROUTING_BINARY_DIR}/doc/latex/en"
                    COMMENT "Converting Latex to PDF format")

                list(APPEND DOC_TARGETS pdf)
            endif()
        endif()

        message("-- Building documentation enabled for: ${DOC_TARGETS}")
    endif()

    #message("END PROCESSING DOCUMENTATION------------")
endif(WITH_DOC)

=== src/astar/sql/CMakeLists.txt ===
# Append in local scope
LIST(APPEND PACKAGE_SQL_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/astarV2.0.sql
    #${CMAKE_CURRENT_SOURCE_DIR}/astarOneToOne.sql

    ${CMAKE_CURRENT_SOURCE_DIR}/_astar.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/astar.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/astarCost.sql
    )

# set in parent scope
SET(PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}" PARENT_SCOPE)

=== src/astar/src/CMakeLists.txt ===
ADD_LIBRARY(astar OBJECT
    many_to_many_astar.c
    many_to_one_astar.c
    one_to_many_astar.c
    one_to_one_astar.c

    astar_many_to_many_driver.cpp
    )

=== src/bdDijkstra/sql/CMakeLists.txt ===
# Append in local scope
LIST(APPEND PACKAGE_SQL_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/bdDijkstra.sql
)

# set in parent scope
SET(PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}" PARENT_SCOPE)

=== src/bd_dijkstra/sql/CMakeLists.txt ===
# Append in local scope
list(APPEND PACKAGE_SQL_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/bdDijkstra-v2.sql
    )

# set in parent scope
set(PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}" PARENT_SCOPE)

=== src/common/src/CMakeLists.txt ===
ADD_LIBRARY(common OBJECT 
    postgres_connection.c
    e_report.c
    restrictions_input.c
    basePath_SSEC.cpp

    points_input.c
    matrixRows_input.c
    get_check_data.c
    edges_input.c
    
    coordinates_input.c
    arrays_input.c

    time_msg.c
    pgr_assert.cpp

    basic_vertex.cpp
    xy_vertex.cpp
    ch_vertex.cpp
    ch_edge.cpp
    basic_edge.cpp
    pgr_alloc.cpp
    )

=== src/convenience/sql/CMakeLists.txt ===
# Append in local scope
LIST(APPEND PACKAGE_SQL_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/pgrouting_conversion_tools.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/pgrouting_dmatrix_tools.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/pgr_vidsToDMatrix.sql
)

# set in parent scope
SET(PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}" PARENT_SCOPE)

=== src/costMatrix/sql/CMakeLists.txt ===
# Append in local scope
LIST(APPEND PACKAGE_SQL_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/withPointsCostMatrix.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/dijkstraCostMatrix.sql
    ${CMAKE_CURRENT_SOURCE_DIR}/astarCostMatrix.sql

    )

# set in parent scope
SET(PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}" PARENT_SCOPE)

=== src/dijkstra/src/CMakeLists.txt ===
ADD_LIBRARY(dijkstra OBJECT
        one_to_one_dijkstra.c
        one_to_many_dijkstra.c
        many_to_one_dijkstra.c
        many_to_many_dijkstra.c
        dijkstraVia.c

        many_to_many_dijkstra_driver.cpp 
        dijkstraVia_driver.cpp)

=== src/max_flow/sql/CMakeLists.txt ===
# Append in local scope
LIST(APPEND PACKAGE_SQL_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/max_flow.sql
        ${CMAKE_CURRENT_SOURCE_DIR}/only_flow.sql
        ${CMAKE_CURRENT_SOURCE_DIR}/maximum_cardinality_matching.sql
        ${CMAKE_CURRENT_SOURCE_DIR}/edge_disjoint_paths.sql
)

# set in parent scope
SET(PACKAGE_SQL_FILES "${PACKAGE_SQL_FILES}" PARENT_SCOPE)

=== src/max_flow/src/CMakeLists.txt ===
ADD_LIBRARY(max_flow OBJECT
        max_flow_one_to_one.c
        max_flow_many_to_many.c
        max_flow_one_to_many.c
        max_flow_many_to_one.c

        maximum_cardinality_matching.c

        edge_disjoint_paths_one_to_one.c
        edge_disjoint_paths_one_to_many.c
        edge_disjoint_paths_many_to_many.c
        edge_disjoint_paths_many_to_one.c

        max_flow_driver.cpp
        maximum_cardinality_matching_driver.cpp
        edge_disjoint_paths_driver.cpp
)

=== debian/changelog ===
pgrouting (2.4.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.0.0, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 16 Aug 2017 18:16:57 +0200

pgrouting (2.4.1-1) unstable; urgency=medium

  * Team upload.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Jun 2017 18:03:18 +0200

pgrouting (2.4.1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 24 Mar 2017 16:58:30 +0100

pgrouting (2.4.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright file, changes:
    - Update copyright years for copyright holders
    - Update file lists for upstream changes
  * Update release_notes.rst path for dh_installchangelogs.
  * Refresh patches.
  * Update HTML files list in doc-base registration.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 21 Mar 2017 07:49:55 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                postgis,
                postgresql-server-dev-all,
                python-sphinx (>= 1.0.7+dfsg)
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/pgrouting.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-grass/pgrouting.git
 Homepage: http://www.pgrouting.org

=== debian/rules ===
--- 
+++ 
@@ -61,7 +61,7 @@
 	dh_install --list-missing
 
 override_dh_installchangelogs:
-	dh_installchangelogs doc/src/changelog/release_notes.rst
+	dh_installchangelogs doc/src/release_notes.rst
 
 override_dh_makeshlibs:
 	dh_makeshlibs -Xusr/lib/postgresql
